<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="generator" content="Asciidoctor 2.0.10">
<meta name="author" content="pukkamustard">
<title>Distributed Mutable Containers</title>
<style>
/* Asciidoctor default stylesheet | MIT License | https://asciidoctor.org */
/* Uncomment @import statement to use as custom stylesheet */
/*@import "https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700";*/
article,aside,details,figcaption,figure,footer,header,hgroup,main,nav,section{display:block}
audio,video{display:inline-block}
audio:not([controls]){display:none;height:0}
html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}
a{background:none}
a:focus{outline:thin dotted}
a:active,a:hover{outline:0}
h1{font-size:2em;margin:.67em 0}
abbr[title]{border-bottom:1px dotted}
b,strong{font-weight:bold}
dfn{font-style:italic}
hr{-moz-box-sizing:content-box;box-sizing:content-box;height:0}
mark{background:#ff0;color:#000}
code,kbd,pre,samp{font-family:monospace;font-size:1em}
pre{white-space:pre-wrap}
q{quotes:"\201C" "\201D" "\2018" "\2019"}
small{font-size:80%}
sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}
sup{top:-.5em}
sub{bottom:-.25em}
img{border:0}
svg:not(:root){overflow:hidden}
figure{margin:0}
fieldset{border:1px solid silver;margin:0 2px;padding:.35em .625em .75em}
legend{border:0;padding:0}
button,input,select,textarea{font-family:inherit;font-size:100%;margin:0}
button,input{line-height:normal}
button,select{text-transform:none}
button,html input[type="button"],input[type="reset"],input[type="submit"]{-webkit-appearance:button;cursor:pointer}
button[disabled],html input[disabled]{cursor:default}
input[type="checkbox"],input[type="radio"]{box-sizing:border-box;padding:0}
button::-moz-focus-inner,input::-moz-focus-inner{border:0;padding:0}
textarea{overflow:auto;vertical-align:top}
table{border-collapse:collapse;border-spacing:0}
*,*::before,*::after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}
html,body{font-size:100%}
body{background:#fff;color:rgba(0,0,0,.8);padding:0;margin:0;font-family:"Noto Serif","DejaVu Serif",serif;font-weight:400;font-style:normal;line-height:1;position:relative;cursor:auto;tab-size:4;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased}
a:hover{cursor:pointer}
img,object,embed{max-width:100%;height:auto}
object,embed{height:100%}
img{-ms-interpolation-mode:bicubic}
.left{float:left!important}
.right{float:right!important}
.text-left{text-align:left!important}
.text-right{text-align:right!important}
.text-center{text-align:center!important}
.text-justify{text-align:justify!important}
.hide{display:none}
img,object,svg{display:inline-block;vertical-align:middle}
textarea{height:auto;min-height:50px}
select{width:100%}
.center{margin-left:auto;margin-right:auto}
.stretch{width:100%}
.subheader,.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{line-height:1.45;color:#7a2518;font-weight:400;margin-top:0;margin-bottom:.25em}
div,dl,dt,dd,ul,ol,li,h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6,pre,form,p,blockquote,th,td{margin:0;padding:0;direction:ltr}
a{color:#2156a5;text-decoration:underline;line-height:inherit}
a:hover,a:focus{color:#1d4b8f}
a img{border:0}
p{font-family:inherit;font-weight:400;font-size:1em;line-height:1.6;margin-bottom:1.25em;text-rendering:optimizeLegibility}
p aside{font-size:.875em;line-height:1.35;font-style:italic}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{font-family:"Open Sans","DejaVu Sans",sans-serif;font-weight:300;font-style:normal;color:#ba3925;text-rendering:optimizeLegibility;margin-top:1em;margin-bottom:.5em;line-height:1.0125em}
h1 small,h2 small,h3 small,#toctitle small,.sidebarblock>.content>.title small,h4 small,h5 small,h6 small{font-size:60%;color:#e99b8f;line-height:0}
h1{font-size:2.125em}
h2{font-size:1.6875em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.375em}
h4,h5{font-size:1.125em}
h6{font-size:1em}
hr{border:solid #dddddf;border-width:1px 0 0;clear:both;margin:1.25em 0 1.1875em;height:0}
em,i{font-style:italic;line-height:inherit}
strong,b{font-weight:bold;line-height:inherit}
small{font-size:60%;line-height:inherit}
code{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;font-weight:400;color:rgba(0,0,0,.9)}
ul,ol,dl{font-size:1em;line-height:1.6;margin-bottom:1.25em;list-style-position:outside;font-family:inherit}
ul,ol{margin-left:1.5em}
ul li ul,ul li ol{margin-left:1.25em;margin-bottom:0;font-size:1em}
ul.square li ul,ul.circle li ul,ul.disc li ul{list-style:inherit}
ul.square{list-style-type:square}
ul.circle{list-style-type:circle}
ul.disc{list-style-type:disc}
ol li ul,ol li ol{margin-left:1.25em;margin-bottom:0}
dl dt{margin-bottom:.3125em;font-weight:bold}
dl dd{margin-bottom:1.25em}
abbr,acronym{text-transform:uppercase;font-size:90%;color:rgba(0,0,0,.8);border-bottom:1px dotted #ddd;cursor:help}
abbr{text-transform:none}
blockquote{margin:0 0 1.25em;padding:.5625em 1.25em 0 1.1875em;border-left:1px solid #ddd}
blockquote cite{display:block;font-size:.9375em;color:rgba(0,0,0,.6)}
blockquote cite::before{content:"\2014 \0020"}
blockquote cite a,blockquote cite a:visited{color:rgba(0,0,0,.6)}
blockquote,blockquote p{line-height:1.6;color:rgba(0,0,0,.85)}
@media screen and (min-width:768px){h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2}
h1{font-size:2.75em}
h2{font-size:2.3125em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.6875em}
h4{font-size:1.4375em}}
table{background:#fff;margin-bottom:1.25em;border:solid 1px #dedede}
table thead,table tfoot{background:#f7f8f7}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;color:rgba(0,0,0,.8);text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit;color:rgba(0,0,0,.8)}
table tr.even,table tr.alt{background:#f8f8f7}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2;word-spacing:-.05em}
h1 strong,h2 strong,h3 strong,#toctitle strong,.sidebarblock>.content>.title strong,h4 strong,h5 strong,h6 strong{font-weight:400}
.clearfix::before,.clearfix::after,.float-group::before,.float-group::after{content:" ";display:table}
.clearfix::after,.float-group::after{clear:both}
:not(pre):not([class^=L])>code{font-size:.9375em;font-style:normal!important;letter-spacing:0;padding:.1em .5ex;word-spacing:-.15em;background:#f7f7f8;-webkit-border-radius:4px;border-radius:4px;line-height:1.45;text-rendering:optimizeSpeed;word-wrap:break-word}
:not(pre)>code.nobreak{word-wrap:normal}
:not(pre)>code.nowrap{white-space:nowrap}
pre{color:rgba(0,0,0,.9);font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;line-height:1.45;text-rendering:optimizeSpeed}
pre code,pre pre{color:inherit;font-size:inherit;line-height:inherit}
pre>code{display:block}
pre.nowrap,pre.nowrap pre{white-space:pre;word-wrap:normal}
em em{font-style:normal}
strong strong{font-weight:400}
.keyseq{color:rgba(51,51,51,.8)}
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}
.menuseq,.menuref{color:#000}
.menuseq b:not(.caret),.menuref{font-weight:inherit}
.menuseq{word-spacing:-.02em}
.menuseq b.caret{font-size:1.25em;line-height:.8}
.menuseq i.caret{font-weight:bold;text-align:center;width:.45em}
b.button::before,b.button::after{position:relative;top:-1px;font-weight:400}
b.button::before{content:"[";padding:0 3px 0 2px}
b.button::after{content:"]";padding:0 2px 0 3px}
p a>code:hover{color:rgba(0,0,0,.9)}
#header,#content,#footnotes,#footer{width:100%;margin-left:auto;margin-right:auto;margin-top:0;margin-bottom:0;max-width:62.5em;*zoom:1;position:relative;padding-left:.9375em;padding-right:.9375em}
#header::before,#header::after,#content::before,#content::after,#footnotes::before,#footnotes::after,#footer::before,#footer::after{content:" ";display:table}
#header::after,#content::after,#footnotes::after,#footer::after{clear:both}
#content{margin-top:1.25em}
#content::before{content:none}
#header>h1:first-child{color:rgba(0,0,0,.85);margin-top:2.25rem;margin-bottom:0}
#header>h1:first-child+#toc{margin-top:8px;border-top:1px solid #dddddf}
#header>h1:only-child,body.toc2 #header>h1:nth-last-child(2){border-bottom:1px solid #dddddf;padding-bottom:8px}
#header .details{border-bottom:1px solid #dddddf;line-height:1.45;padding-top:.25em;padding-bottom:.25em;padding-left:.25em;color:rgba(0,0,0,.6);display:-ms-flexbox;display:-webkit-flex;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap}
#header .details span:first-child{margin-left:-.125em}
#header .details span.email a{color:rgba(0,0,0,.85)}
#header .details br{display:none}
#header .details br+span::before{content:"\00a0\2013\00a0"}
#header .details br+span.author::before{content:"\00a0\22c5\00a0";color:rgba(0,0,0,.85)}
#header .details br+span#revremark::before{content:"\00a0|\00a0"}
#header #revnumber{text-transform:capitalize}
#header #revnumber::after{content:"\00a0"}
#content>h1:first-child:not([class]){color:rgba(0,0,0,.85);border-bottom:1px solid #dddddf;padding-bottom:8px;margin-top:0;padding-top:1rem;margin-bottom:1.25rem}
#toc{border-bottom:1px solid #e7e7e9;padding-bottom:.5em}
#toc>ul{margin-left:.125em}
#toc ul.sectlevel0>li>a{font-style:italic}
#toc ul.sectlevel0 ul.sectlevel1{margin:.5em 0}
#toc ul{font-family:"Open Sans","DejaVu Sans",sans-serif;list-style-type:none}
#toc li{line-height:1.3334;margin-top:.3334em}
#toc a{text-decoration:none}
#toc a:active{text-decoration:underline}
#toctitle{color:#7a2518;font-size:1.2em}
@media screen and (min-width:768px){#toctitle{font-size:1.375em}
body.toc2{padding-left:15em;padding-right:0}
#toc.toc2{margin-top:0!important;background:#f8f8f7;position:fixed;width:15em;left:0;top:0;border-right:1px solid #e7e7e9;border-top-width:0!important;border-bottom-width:0!important;z-index:1000;padding:1.25em 1em;height:100%;overflow:auto}
#toc.toc2 #toctitle{margin-top:0;margin-bottom:.8rem;font-size:1.2em}
#toc.toc2>ul{font-size:.9em;margin-bottom:0}
#toc.toc2 ul ul{margin-left:0;padding-left:1em}
#toc.toc2 ul.sectlevel0 ul.sectlevel1{padding-left:0;margin-top:.5em;margin-bottom:.5em}
body.toc2.toc-right{padding-left:0;padding-right:15em}
body.toc2.toc-right #toc.toc2{border-right-width:0;border-left:1px solid #e7e7e9;left:auto;right:0}}
@media screen and (min-width:1280px){body.toc2{padding-left:20em;padding-right:0}
#toc.toc2{width:20em}
#toc.toc2 #toctitle{font-size:1.375em}
#toc.toc2>ul{font-size:.95em}
#toc.toc2 ul ul{padding-left:1.25em}
body.toc2.toc-right{padding-left:0;padding-right:20em}}
#content #toc{border-style:solid;border-width:1px;border-color:#e0e0dc;margin-bottom:1.25em;padding:1.25em;background:#f8f8f7;-webkit-border-radius:4px;border-radius:4px}
#content #toc>:first-child{margin-top:0}
#content #toc>:last-child{margin-bottom:0}
#footer{max-width:100%;background:rgba(0,0,0,.8);padding:1.25em}
#footer-text{color:rgba(255,255,255,.8);line-height:1.44}
#content{margin-bottom:.625em}
.sect1{padding-bottom:.625em}
@media screen and (min-width:768px){#content{margin-bottom:1.25em}
.sect1{padding-bottom:1.25em}}
.sect1:last-child{padding-bottom:0}
.sect1+.sect1{border-top:1px solid #e7e7e9}
#content h1>a.anchor,h2>a.anchor,h3>a.anchor,#toctitle>a.anchor,.sidebarblock>.content>.title>a.anchor,h4>a.anchor,h5>a.anchor,h6>a.anchor{position:absolute;z-index:1001;width:1.5ex;margin-left:-1.5ex;display:block;text-decoration:none!important;visibility:hidden;text-align:center;font-weight:400}
#content h1>a.anchor::before,h2>a.anchor::before,h3>a.anchor::before,#toctitle>a.anchor::before,.sidebarblock>.content>.title>a.anchor::before,h4>a.anchor::before,h5>a.anchor::before,h6>a.anchor::before{content:"\00A7";font-size:.85em;display:block;padding-top:.1em}
#content h1:hover>a.anchor,#content h1>a.anchor:hover,h2:hover>a.anchor,h2>a.anchor:hover,h3:hover>a.anchor,#toctitle:hover>a.anchor,.sidebarblock>.content>.title:hover>a.anchor,h3>a.anchor:hover,#toctitle>a.anchor:hover,.sidebarblock>.content>.title>a.anchor:hover,h4:hover>a.anchor,h4>a.anchor:hover,h5:hover>a.anchor,h5>a.anchor:hover,h6:hover>a.anchor,h6>a.anchor:hover{visibility:visible}
#content h1>a.link,h2>a.link,h3>a.link,#toctitle>a.link,.sidebarblock>.content>.title>a.link,h4>a.link,h5>a.link,h6>a.link{color:#ba3925;text-decoration:none}
#content h1>a.link:hover,h2>a.link:hover,h3>a.link:hover,#toctitle>a.link:hover,.sidebarblock>.content>.title>a.link:hover,h4>a.link:hover,h5>a.link:hover,h6>a.link:hover{color:#a53221}
details,.audioblock,.imageblock,.literalblock,.listingblock,.stemblock,.videoblock{margin-bottom:1.25em}
details>summary:first-of-type{cursor:pointer;display:list-item;outline:none;margin-bottom:.75em}
.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{text-rendering:optimizeLegibility;text-align:left;font-family:"Noto Serif","DejaVu Serif",serif;font-size:1rem;font-style:italic}
table.tableblock.fit-content>caption.title{white-space:nowrap;width:0}
.paragraph.lead>p,#preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:1.21875em;line-height:1.6;color:rgba(0,0,0,.85)}
table.tableblock #preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:inherit}
.admonitionblock>table{border-collapse:separate;border:0;background:none;width:100%}
.admonitionblock>table td.icon{text-align:center;width:80px}
.admonitionblock>table td.icon img{max-width:none}
.admonitionblock>table td.icon .title{font-weight:bold;font-family:"Open Sans","DejaVu Sans",sans-serif;text-transform:uppercase}
.admonitionblock>table td.content{padding-left:1.125em;padding-right:1.25em;border-left:1px solid #dddddf;color:rgba(0,0,0,.6)}
.admonitionblock>table td.content>:last-child>:last-child{margin-bottom:0}
.exampleblock>.content{border-style:solid;border-width:1px;border-color:#e6e6e6;margin-bottom:1.25em;padding:1.25em;background:#fff;-webkit-border-radius:4px;border-radius:4px}
.exampleblock>.content>:first-child{margin-top:0}
.exampleblock>.content>:last-child{margin-bottom:0}
.sidebarblock{border-style:solid;border-width:1px;border-color:#dbdbd6;margin-bottom:1.25em;padding:1.25em;background:#f3f3f2;-webkit-border-radius:4px;border-radius:4px}
.sidebarblock>:first-child{margin-top:0}
.sidebarblock>:last-child{margin-bottom:0}
.sidebarblock>.content>.title{color:#7a2518;margin-top:0;text-align:center}
.exampleblock>.content>:last-child>:last-child,.exampleblock>.content .olist>ol>li:last-child>:last-child,.exampleblock>.content .ulist>ul>li:last-child>:last-child,.exampleblock>.content .qlist>ol>li:last-child>:last-child,.sidebarblock>.content>:last-child>:last-child,.sidebarblock>.content .olist>ol>li:last-child>:last-child,.sidebarblock>.content .ulist>ul>li:last-child>:last-child,.sidebarblock>.content .qlist>ol>li:last-child>:last-child{margin-bottom:0}
.literalblock pre,.listingblock>.content>pre{-webkit-border-radius:4px;border-radius:4px;word-wrap:break-word;overflow-x:auto;padding:1em;font-size:.8125em}
@media screen and (min-width:768px){.literalblock pre,.listingblock>.content>pre{font-size:.90625em}}
@media screen and (min-width:1280px){.literalblock pre,.listingblock>.content>pre{font-size:1em}}
.literalblock pre,.listingblock>.content>pre:not(.highlight),.listingblock>.content>pre[class="highlight"],.listingblock>.content>pre[class^="highlight "]{background:#f7f7f8}
.literalblock.output pre{color:#f7f7f8;background:rgba(0,0,0,.9)}
.listingblock>.content{position:relative}
.listingblock code[data-lang]::before{display:none;content:attr(data-lang);position:absolute;font-size:.75em;top:.425rem;right:.5rem;line-height:1;text-transform:uppercase;color:inherit;opacity:.5}
.listingblock:hover code[data-lang]::before{display:block}
.listingblock.terminal pre .command::before{content:attr(data-prompt);padding-right:.5em;color:inherit;opacity:.5}
.listingblock.terminal pre .command:not([data-prompt])::before{content:"$"}
.listingblock pre.highlightjs{padding:0}
.listingblock pre.highlightjs>code{padding:1em;-webkit-border-radius:4px;border-radius:4px}
.listingblock pre.prettyprint{border-width:0}
.prettyprint{background:#f7f7f8}
pre.prettyprint .linenums{line-height:1.45;margin-left:2em}
pre.prettyprint li{background:none;list-style-type:inherit;padding-left:0}
pre.prettyprint li code[data-lang]::before{opacity:1}
pre.prettyprint li:not(:first-child) code[data-lang]::before{display:none}
table.linenotable{border-collapse:separate;border:0;margin-bottom:0;background:none}
table.linenotable td[class]{color:inherit;vertical-align:top;padding:0;line-height:inherit;white-space:normal}
table.linenotable td.code{padding-left:.75em}
table.linenotable td.linenos{border-right:1px solid currentColor;opacity:.35;padding-right:.5em}
pre.pygments .lineno{border-right:1px solid currentColor;opacity:.35;display:inline-block;margin-right:.75em}
pre.pygments .lineno::before{content:"";margin-right:-.125em}
.quoteblock{margin:0 1em 1.25em 1.5em;display:table}
.quoteblock:not(.excerpt)>.title{margin-left:-1.5em;margin-bottom:.75em}
.quoteblock blockquote,.quoteblock p{color:rgba(0,0,0,.85);font-size:1.15rem;line-height:1.75;word-spacing:.1em;letter-spacing:0;font-style:italic;text-align:justify}
.quoteblock blockquote{margin:0;padding:0;border:0}
.quoteblock blockquote::before{content:"\201c";float:left;font-size:2.75em;font-weight:bold;line-height:.6em;margin-left:-.6em;color:#7a2518;text-shadow:0 1px 2px rgba(0,0,0,.1)}
.quoteblock blockquote>.paragraph:last-child p{margin-bottom:0}
.quoteblock .attribution{margin-top:.75em;margin-right:.5ex;text-align:right}
.verseblock{margin:0 1em 1.25em}
.verseblock pre{font-family:"Open Sans","DejaVu Sans",sans;font-size:1.15rem;color:rgba(0,0,0,.85);font-weight:300;text-rendering:optimizeLegibility}
.verseblock pre strong{font-weight:400}
.verseblock .attribution{margin-top:1.25rem;margin-left:.5ex}
.quoteblock .attribution,.verseblock .attribution{font-size:.9375em;line-height:1.45;font-style:italic}
.quoteblock .attribution br,.verseblock .attribution br{display:none}
.quoteblock .attribution cite,.verseblock .attribution cite{display:block;letter-spacing:-.025em;color:rgba(0,0,0,.6)}
.quoteblock.abstract blockquote::before,.quoteblock.excerpt blockquote::before,.quoteblock .quoteblock blockquote::before{display:none}
.quoteblock.abstract blockquote,.quoteblock.abstract p,.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{line-height:1.6;word-spacing:0}
.quoteblock.abstract{margin:0 1em 1.25em;display:block}
.quoteblock.abstract>.title{margin:0 0 .375em;font-size:1.15em;text-align:center}
.quoteblock.excerpt>blockquote,.quoteblock .quoteblock{padding:0 0 .25em 1em;border-left:.25em solid #dddddf}
.quoteblock.excerpt,.quoteblock .quoteblock{margin-left:0}
.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{color:inherit;font-size:1.0625rem}
.quoteblock.excerpt .attribution,.quoteblock .quoteblock .attribution{color:inherit;text-align:left;margin-right:0}
table.tableblock{max-width:100%;border-collapse:separate}
p.tableblock:last-child{margin-bottom:0}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
td.tableblock>.content>:last-child.sidebarblock{margin-bottom:0}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
table.stripes-all tr,table.stripes-odd tr:nth-of-type(odd),table.stripes-even tr:nth-of-type(even),table.stripes-hover tr:hover{background:#f8f8f7}
th.halign-left,td.halign-left{text-align:left}
th.halign-right,td.halign-right{text-align:right}
th.halign-center,td.halign-center{text-align:center}
th.valign-top,td.valign-top{vertical-align:top}
th.valign-bottom,td.valign-bottom{vertical-align:bottom}
th.valign-middle,td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6;background:#f7f8f7}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{color:rgba(0,0,0,.8);font-weight:bold}
p.tableblock>code:only-child{background:none;padding:0}
p.tableblock{font-size:1em}
ol{margin-left:1.75em}
ul li ol{margin-left:1.5em}
dl dd{margin-left:1.125em}
dl dd:last-child,dl dd:last-child>:last-child{margin-bottom:0}
ol>li p,ul>li p,ul dd,ol dd,.olist .olist,.ulist .ulist,.ulist .olist,.olist .ulist{margin-bottom:.625em}
ul.checklist,ul.none,ol.none,ul.no-bullet,ol.no-bullet,ol.unnumbered,ul.unstyled,ol.unstyled{list-style-type:none}
ul.no-bullet,ol.no-bullet,ol.unnumbered{margin-left:.625em}
ul.unstyled,ol.unstyled{margin-left:0}
ul.checklist{margin-left:.625em}
ul.checklist li>p:first-child>.fa-square-o:first-child,ul.checklist li>p:first-child>.fa-check-square-o:first-child{width:1.25em;font-size:.8em;position:relative;bottom:.125em}
ul.checklist li>p:first-child>input[type="checkbox"]:first-child{margin-right:.25em}
ul.inline{display:-ms-flexbox;display:-webkit-box;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap;list-style:none;margin:0 0 .625em -1.25em}
ul.inline>li{margin-left:1.25em}
.unstyled dl dt{font-weight:400;font-style:normal}
ol.arabic{list-style-type:decimal}
ol.decimal{list-style-type:decimal-leading-zero}
ol.loweralpha{list-style-type:lower-alpha}
ol.upperalpha{list-style-type:upper-alpha}
ol.lowerroman{list-style-type:lower-roman}
ol.upperroman{list-style-type:upper-roman}
ol.lowergreek{list-style-type:lower-greek}
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
.literalblock+.colist,.listingblock+.colist{margin-top:-.5em}
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}
.thumb,.th{line-height:0;display:inline-block;border:solid 4px #fff;-webkit-box-shadow:0 0 0 1px #ddd;box-shadow:0 0 0 1px #ddd}
.imageblock.left{margin:.25em .625em 1.25em 0}
.imageblock.right{margin:.25em 0 1.25em .625em}
.imageblock>.title{margin-bottom:0}
.imageblock.thumb,.imageblock.th{border-width:6px}
.imageblock.thumb>.title,.imageblock.th>.title{padding:0 .125em}
.image.left,.image.right{margin-top:.25em;margin-bottom:.25em;display:inline-block;line-height:0}
.image.left{margin-right:.625em}
.image.right{margin-left:.625em}
a.image{text-decoration:none;display:inline-block}
a.image object{pointer-events:none}
sup.footnote,sup.footnoteref{font-size:.875em;position:static;vertical-align:super}
sup.footnote a,sup.footnoteref a{text-decoration:none}
sup.footnote a:active,sup.footnoteref a:active{text-decoration:underline}
#footnotes{padding-top:.75em;padding-bottom:.75em;margin-bottom:.625em}
#footnotes hr{width:20%;min-width:6.25em;margin:-.25em 0 .75em;border-width:1px 0 0}
#footnotes .footnote{padding:0 .375em 0 .225em;line-height:1.3334;font-size:.875em;margin-left:1.2em;margin-bottom:.2em}
#footnotes .footnote a:first-of-type{font-weight:bold;text-decoration:none;margin-left:-1.05em}
#footnotes .footnote:last-of-type{margin-bottom:0}
#content #footnotes{margin-top:-.625em;margin-bottom:0;padding:.75em 0}
.gist .file-data>table{border:0;background:#fff;width:100%;margin-bottom:0}
.gist .file-data>table td.line-data{width:99%}
div.unbreakable{page-break-inside:avoid}
.big{font-size:larger}
.small{font-size:smaller}
.underline{text-decoration:underline}
.overline{text-decoration:overline}
.line-through{text-decoration:line-through}
.aqua{color:#00bfbf}
.aqua-background{background:#00fafa}
.black{color:#000}
.black-background{background:#000}
.blue{color:#0000bf}
.blue-background{background:#0000fa}
.fuchsia{color:#bf00bf}
.fuchsia-background{background:#fa00fa}
.gray{color:#606060}
.gray-background{background:#7d7d7d}
.green{color:#006000}
.green-background{background:#007d00}
.lime{color:#00bf00}
.lime-background{background:#00fa00}
.maroon{color:#600000}
.maroon-background{background:#7d0000}
.navy{color:#000060}
.navy-background{background:#00007d}
.olive{color:#606000}
.olive-background{background:#7d7d00}
.purple{color:#600060}
.purple-background{background:#7d007d}
.red{color:#bf0000}
.red-background{background:#fa0000}
.silver{color:#909090}
.silver-background{background:#bcbcbc}
.teal{color:#006060}
.teal-background{background:#007d7d}
.white{color:#bfbfbf}
.white-background{background:#fafafa}
.yellow{color:#bfbf00}
.yellow-background{background:#fafa00}
span.icon>.fa{cursor:default}
a span.icon>.fa{cursor:inherit}
.admonitionblock td.icon [class^="fa icon-"]{font-size:2.5em;text-shadow:1px 1px 2px rgba(0,0,0,.5);cursor:default}
.admonitionblock td.icon .icon-note::before{content:"\f05a";color:#19407c}
.admonitionblock td.icon .icon-tip::before{content:"\f0eb";text-shadow:1px 1px 2px rgba(155,155,0,.8);color:#111}
.admonitionblock td.icon .icon-warning::before{content:"\f071";color:#bf6900}
.admonitionblock td.icon .icon-caution::before{content:"\f06d";color:#bf3400}
.admonitionblock td.icon .icon-important::before{content:"\f06a";color:#bf0000}
.conum[data-value]{display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:100px;border-radius:100px;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]::after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
dt,th.tableblock,td.content,div.footnote{text-rendering:optimizeLegibility}
h1,h2,p,td.content,span.alt{letter-spacing:-.01em}
p strong,td.content strong,div.footnote strong{letter-spacing:-.005em}
p,blockquote,dt,td.content,span.alt{font-size:1.0625rem}
p{margin-bottom:1.25rem}
.sidebarblock p,.sidebarblock dt,.sidebarblock td.content,p.tableblock{font-size:1em}
.exampleblock>.content{background:#fffef7;border-color:#e0e0dc;-webkit-box-shadow:0 1px 4px #e0e0dc;box-shadow:0 1px 4px #e0e0dc}
.print-only{display:none!important}
@page{margin:1.25cm .75cm}
@media print{*{-webkit-box-shadow:none!important;box-shadow:none!important;text-shadow:none!important}
html{font-size:80%}
a{color:inherit!important;text-decoration:underline!important}
a.bare,a[href^="#"],a[href^="mailto:"]{text-decoration:none!important}
a[href^="http:"]:not(.bare)::after,a[href^="https:"]:not(.bare)::after{content:"(" attr(href) ")";display:inline-block;font-size:.875em;padding-left:.25em}
abbr[title]::after{content:" (" attr(title) ")"}
pre,blockquote,tr,img,object,svg{page-break-inside:avoid}
thead{display:table-header-group}
svg{max-width:100%}
p,blockquote,dt,td.content{font-size:1em;orphans:3;widows:3}
h2,h3,#toctitle,.sidebarblock>.content>.title{page-break-after:avoid}
#toc,.sidebarblock,.exampleblock>.content{background:none!important}
#toc{border-bottom:1px solid #dddddf!important;padding-bottom:0!important}
body.book #header{text-align:center}
body.book #header>h1:first-child{border:0!important;margin:2.5em 0 1em}
body.book #header .details{border:0!important;display:block;padding:0!important}
body.book #header .details span:first-child{margin-left:0!important}
body.book #header .details br{display:block}
body.book #header .details br+span::before{content:none!important}
body.book #toc{border:0!important;text-align:left!important;padding:0!important;margin:0!important}
body.book #toc,body.book #preamble,body.book h1.sect0,body.book .sect1>h2{page-break-before:always}
.listingblock code[data-lang]::before{display:block}
#footer{padding:0 .9375em}
.hide-on-print{display:none!important}
.print-only{display:block!important}
.hide-for-print{display:none!important}
.show-for-print{display:inherit!important}}
@media print,amzn-kf8{#header>h1:first-child{margin-top:1.25rem}
.sect1{padding:0!important}
.sect1+.sect1{border:0}
#footer{background:none}
#footer-text{color:rgba(0,0,0,.6);font-size:.9em}}
@media amzn-kf8{#header,#content,#footnotes,#footer{padding:0}}
</style>
</head>
<body class="article toc2 toc-left">
<div id="header">
<h1>Distributed Mutable Containers</h1>
<div class="details">
<span id="author" class="author">pukkamustard</span><br>
<span id="email" class="email"><a href="mailto:pukkamustard@posteo.net">pukkamustard@posteo.net</a></span><br>
<span id="revnumber">version 0.1.0,</span>
<span id="revdate">2020-10-19</span>
</div>
<div id="toc" class="toc2">
<div id="toctitle">Table of Contents</div>
<ul class="sectlevel1">
<li><a href="#_introduction">1. Introduction</a></li>
<li><a href="#_prerequisites">2. Prerequisites</a>
<ul class="sectlevel2">
<li><a href="#_content_addressable_rdf_and_eris">2.1. Content-addressable RDF and ERIS</a></li>
<li><a href="#_rdf_signfiy">2.2. RDF Signfiy</a></li>
<li><a href="#_commutative_replicated_data_types">2.3. Commutative Replicated Data Types</a></li>
<li><a href="#_datalog">2.4. Datalog</a></li>
</ul>
</li>
<li><a href="#_distributed_mutable_containers">3. Distributed Mutable Containers</a>
<ul class="sectlevel2">
<li><a href="#_definition">3.1. Definition</a></li>
<li><a href="#_identifier">3.2. Identifier</a></li>
<li><a href="#_operations">3.3. Operations</a></li>
<li><a href="#_state">3.4. State</a></li>
</ul>
</li>
<li><a href="#_container_types">4. Container types</a>
<ul class="sectlevel2">
<li><a href="#_set">4.1. Set</a></li>
<li><a href="#_register">4.2. Register</a></li>
</ul>
</li>
<li><a href="#_further_work">5. Further work</a></li>
<li><a href="#_acknowledgments">6. Acknowledgments</a></li>
<li><a href="#_rdf_vocabulary">Appendix A: RDF Vocabulary</a></li>
<li><a href="#_copyright">Appendix B: Copyright</a></li>
<li><a href="#_references">References</a></li>
</ul>
</div>
</div>
<div id="content">
<div id="preamble">
<div class="sectionbody">
<div class="quoteblock abstract">
<blockquote>
Distributed Mutable Containers are distributed data structures that are capable of holding references to arbitrary content while allowing replicas of the data structures to diverge out conflict. We present a concrete implementation of a set (holding multiple values) and a register (holding a single value). Containers are based on Commutative Replicated Data Types (CRDTs). Compared to distributed data structures based on append-only logs (e.g. Hypercore or Secure ScuttleBut) these CRDT based containers allow collective and shared control where authorization to mutate containers can be delegated.  Furthermore they do not require the entire history to be known to compute current state which improves efficiency and allows "the right to be forgotten". The containers are specified independently of any transport or storage layer and can be used as underlying data structures for systems implementing ActivityPub, Linked Data Platform over conventional HTTP or systems built on more decentralized technology and network topologies. We present a RDF vocabulary for describing containers, state and operations as well as the semantics for computing container state.
</blockquote>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_introduction"><a class="anchor" href="#_introduction"></a>1. Introduction</h2>
<div class="sectionbody">
<div class="paragraph">
<p>In previous work we have illustrated how content-addressing can be used to make system  more robust and secure <a href="#eris">[eris]</a>. However, content-addressed data is immutable. A reference to a piece of content will always refer to the exactly same content. This is very desirable for many applications and the reason why content-addressing allows more robust systems.</p>
</div>
<div class="paragraph">
<p>Nevertheless, there are applications where one wants to reference mutable content. Examples include user profiles or dynamic collections of content. Making small changes to a user profile or adding a piece of content to a collection should preserve the identifiers.</p>
</div>
<div class="paragraph">
<p>Conventional URLs, i.e. networks addresses of a host that make content available, allow mutable content: the host simply returns the updated content. However, this requires trusting the host to always return the right content as well as relying on the host to be available to provide content.</p>
</div>
<div class="paragraph">
<p>Public-key cryptography can be used to reduce trust and reliance on a single host while allowing mutable content. Systems like Hypercore (previously Dat) and Secure ScuttleBut (SSB) allow content to be referenced by a public key where holders of the associated secret key can publish updates. There is no need to trust or rely on a single host as the content can be verified to have been published by a holder of the secret key and the content does not need to be stored on a single host.</p>
</div>
<div class="paragraph">
<p>Hypercore and SSB (and other similar systems) use an append-only log to keep track of history. This has two major drawbacks:</p>
</div>
<div class="olist arabic">
<ol class="arabic">
<li>
<p>It is not possible to delete content. This leads to performance as well as privacy issues.</p>
</li>
<li>
<p>The state of the container may not fork (i.e. the state must always be a proper linked list with a single head). This practically prevents shared control of a container by multiple parties as it would require a high degree of out-of-band coordination to prevent a fork.</p>
</li>
</ol>
</div>
<div class="paragraph">
<p>In the following we specify two mutable containers that improve on append-only logs by using Commutative Replicated Data Types (CRDTs) as underlying data structures:</p>
</div>
<div class="ulist">
<ul>
<li>
<p>A set that can hold multiple references to content.</p>
</li>
<li>
<p>A register that at any given moment holds at most a single reference to content.</p>
</li>
</ul>
</div>
<div class="paragraph">
<p>By using CRDTs the state of containers is allowed to diverge and is guaranteed to converge on a consistent state eventually. Furthermore, the container history can be garbage collected, allowing content that has been removed from the container to be forgotten.</p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_prerequisites"><a class="anchor" href="#_prerequisites"></a>2. Prerequisites</h2>
<div class="sectionbody">
<div class="sect2">
<h3 id="_content_addressable_rdf_and_eris"><a class="anchor" href="#_content_addressable_rdf_and_eris"></a>2.1. Content-addressable RDF and ERIS</h3>
<div class="paragraph">
<p>We use the scheme for content-addressing as described in previous work <a href="#content-addressable-rdf">[content-addressable-rdf]</a> as well as the ERIS <a href="#eris">[eris]</a> encoding. This allows us to refer to operations as well as state using an identifier that is determined by the content of the operations as well as enable secure transport and storage.</p>
</div>
<div class="paragraph">
<p>Example RDF data will be shown in the RDF/Turtle serialization format - a human readable format.</p>
</div>
</div>
<div class="sect2">
<h3 id="_rdf_signfiy"><a class="anchor" href="#_rdf_signfiy"></a>2.2. RDF Signfiy</h3>
<div class="paragraph">
<p>To ensure authenticity of operations and verify that operations are authorized we use the Ed25519 algorithm for cryptographic signatures and the RDF Signify vocabulary for describing signatures <a href="#rdf-signify">[rdf-signify]</a>.</p>
</div>
</div>
<div class="sect2">
<h3 id="_commutative_replicated_data_types"><a class="anchor" href="#_commutative_replicated_data_types"></a>2.3. Commutative Replicated Data Types</h3>
<div class="paragraph">
<p>Conflict-free replicated data types is a class of data structures that may replicated over hosts, updated independantly and guaranteed to be mergeable without conflict.</p>
</div>
<div class="paragraph">
<p>There are two sub-classes of conflict-free replicated data types: Convergent Replicated Data Types (state based) and Commutative Replicated Data Types (operation based). We will use Commutative Replicated Data Types.</p>
</div>
<div class="paragraph">
<p>Commutative Replicated Data Types rely on the fact that operations that mutate the data structures commute, i.e. the order in which the operations are applied does not change the outcome. This guarantees that distributed replicas of a CRDT converge to the same state as soon as the same set of operations are applied at both replicas (regardless of order). This property is called <em>strong eventual consistency</em>.</p>
</div>
<div class="paragraph">
<p>We will use two types of CRDTs: An Observed-Remove Set (section <a href="#_set">Set</a>) and a Last-Writer-Win Register (section <a href="#_register">Register</a>) and will introduce both in the respective sections.</p>
</div>
<div class="paragraph">
<p>The reader is referred to Shapiro et. al. <a href="#crdt">[crdt]</a> for a formal treatment and an overview of the various types of CRDTs.</p>
</div>
</div>
<div class="sect2">
<h3 id="_datalog"><a class="anchor" href="#_datalog"></a>2.4. Datalog</h3>
<div class="paragraph">
<p>Datalog is a declarative logic programming language. It has a very simple syntax and exactly defined semantics that make it useful as a query language for databases.</p>
</div>
<div class="paragraph">
<p>We will use Datalog as a specification language for describing semantics of containers. This allows a very concise description that can be directly used in existing, efficient implementations of Datalog. Furthermore, certain aspects of Datalog semantics (monotonicity) make it perfectly adapted for reasoning about distributed systems <a href="#calm">[calm]</a>.</p>
</div>
<div class="paragraph">
<p>Datalog can also be used as an application level query language (e.g. for answering queries like "all posts about cats posted by people that I have sent a message to in the last year"). The query can be combined with container state resolution queries to a single query. This unified approach of querying data seems very appealing and we hope to investigate it further work.</p>
</div>
<div class="paragraph">
<p>We require two extensions of Datalog which are well studied in the literature: Built-in predicates (for computing cryptographic functions) and stratified negation. For the register container we also require aggregation. The author needs to do more work to understand how aggregation works in Datalog. All required extensions are available in the open-source Datalog implementation <a href="https://souffle-lang.github.io/index.html">Soufflé</a>, which was used to develop and test the work presented. A runable implementation of container semantics and examples are available in the <a href="http://gitlab.com/openengiadina/dmc">DMC repository</a>.</p>
</div>
<div class="paragraph">
<p>The predicate <code>graph</code> is used for accessing the RDF graph that contains all triples to be considered (in the Datalog literature this is called an <em>extensional database</em>). We assume that everything in the graph is content-addressed with ERIS <a href="#content-addressable-rdf">[content-addressable-rdf]</a>.</p>
</div>
<div class="paragraph">
<p>Following built-in predicate are used:</p>
</div>
<div class="dlist">
<dl>
<dt class="hdlist1"><code>ed25519Verify</code> </dt>
<dd>
<p>Verifies a Ed25519 signature given a public-key and a signature, i.e. <code>ed25519Verify(signature, message, publicKey)</code> if <code>signature</code> is a valid Ed25519 signature of <code>message</code> with public-key <code>publicKey</code>.</p>
</dd>
</dl>
</div>
<div class="paragraph">
<p>The Datalog syntax used is very similar to that of Soufflé with the difference that we always use identifiers starting with upper-case to denote variables and lower-case to indicate symbols (instead of delimiting them in quotation marks). We use a shorthand for IRI constants, e.g. <code>dmc:Set</code> expands to <code><a href="http://purl.org/dmc#Set" class="bare">http://purl.org/dmc#Set</a></code>. Additionally we use the shorthand <code>a</code> for <code>rdf:type</code>.</p>
</div>
<div class="paragraph">
<p>For a formal introduction to Datalog the reader is referred to the overview paper by Ceri et. al. "What you always wanted to know about Datalog (and never dared to ask)" <a href="#datalog">[datalog]</a>.</p>
</div>
<div class="paragraph">
<p>Alternative Datalog implementations that can be used include <a href="https://abcdatalog.seas.harvard.edu/">AbcDatalog</a>. However, AbcDatalog can only be used for the Set container as it lacks aggregation. A Guile Datalog implementation that will be usable for both containers presented is being developed (<a href="https://gitlab.com/openengiadina/guile-schemantic">guile-schemantic</a>).</p>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_distributed_mutable_containers"><a class="anchor" href="#_distributed_mutable_containers"></a>3. Distributed Mutable Containers</h2>
<div class="sectionbody">
<div class="paragraph">
<p>In a nutshell a Distributed Mutable Container works as follows:</p>
</div>
<div class="olist arabic">
<ol class="arabic">
<li>
<p>A Distributed Mutable Container is defined as an immutable RDF graph (section <a href="#_definition">Definition</a>).</p>
</li>
<li>
<p>A <em>container identifier</em> is derived from the immutable reference of the container definition that can be used to resolve the dynamic state of a container (section <a href="#_identifier">Identifier</a>).</p>
</li>
<li>
<p>Operations are created that mutate a container (section <a href="#_operations">Operations</a>).</p>
</li>
<li>
<p>Resolving a container identifier returns the current <em>container state</em> based on available operations. An overview of this process is given in section <a href="#_operations_and_resolving_container_state">[_operations_and_resolving_container_state]</a>. The exact semantics of how to resolve the current state is defined for the different container types in section <a href="#_container_types">Container types</a>.</p>
</li>
</ol>
</div>
<div class="sect2">
<h3 id="_definition"><a class="anchor" href="#_definition"></a>3.1. Definition</h3>
<div class="paragraph">
<p>A container is created by creating a container definition, which is a content-addressed RDF graph (using ERIS) describing the type of the container and the root public key.</p>
</div>
<div class="paragraph">
<p>The root public key is the public key of the associated secret key that can be used to mutate the container. The property is formally defined in the RDF vocabulary (section <a href="#_rdf_vocabulary">RDF Vocabulary</a>).</p>
</div>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<div class="title">Note</div>
</td>
<td class="content">
The root public key is called so because we intend the list of keys that can mutate the container to be extendable in the future (whereas the root public key stays fixed).
</td>
</tr>
</table>
</div>
<div class="paragraph">
<p>For example a container definition for a set (defined in section <a href="#_set">Set</a>):</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-turtle" data-lang="turtle">@prefix dmc: &lt;http://purl.org/dmc#&gt; .

&lt;urn:erisx2:AAAELYRT24S2SACAPSMGTNYYHCCQHBDGQH3SC3K3Y35PI73SLTA6JTO7S7XTA66LZQ2OKSAZZI4BWXJCGGJLZ74WIWEMXZ2SXDC4JVAFKM&gt;
    a dmc:SetDefinition ;
    dmc:rootPublicKey &lt;urn:ed25519:pk:O7RZC7XVKCRU4LFT4ACSBP3GQ55PPGBZHCBQJMJ46VKJN63HOMSA&gt; .</code></pre>
</div>
</div>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<div class="title">Note</div>
</td>
<td class="content">
The root public key is encoded as specified by RDF Signify <a href="#rdf-signify">[rdf-signify]</a>.
</td>
</tr>
</table>
</div>
<div class="admonitionblock warning">
<table>
<tr>
<td class="icon">
<div class="title">Warning</div>
</td>
<td class="content">
The URN of ERIS encoded content is not yet finalized.
</td>
</tr>
</table>
</div>
<div class="paragraph">
<p>The container definition is immutable. References to the container definition URN always resolve the same content. To resolve the dynamic and mutable stae of a container we use the <em>container identifier</em>.</p>
</div>
<div class="paragraph">
<p>A container definition has the type (<code>rdf:type</code> property) <code>dmc:SetDefinition</code> or <code>dmc:RegisterDefinition</code>. Both <code>dmc:SetDefinition</code> and <code>dmc:RegisterDefinition</code> are defined as sub-classes of <code>dmc:ContainerDefinition</code> using the <code>rdfs:subClassOf</code> property.</p>
</div>
</div>
<div class="sect2">
<h3 id="_identifier"><a class="anchor" href="#_identifier"></a>3.2. Identifier</h3>
<div class="paragraph">
<p>To reference the dynamic and mutable state of a container we use the special URN scheme <code>dmc:CONTAINER_DEFINITION_ERIS_CAPABILITY</code> where <code>CONTAINER_DEFINITION_ERIS_CAPABILITY</code> is the encoded ERIS read capability.</p>
</div>
<div class="paragraph">
<p>For example the identifier for the container defined in the previous sections is:</p>
</div>
<div class="paragraph">
<p><code>dmc:AAAELYRT24S2SACAPSMGTNYYHCCQHBDGQH3SC3K3Y35PI73SLTA6JTO7S7XTA66LZQ2OKSAZZI4BWXJCGGJLZ74WIWEMXZ2SXDC4JVAFKM</code></p>
</div>
</div>
<div class="sect2">
<h3 id="_operations"><a class="anchor" href="#_operations"></a>3.3. Operations</h3>
<div class="paragraph">
<p>Operations mutate container state. They are represented as RDF graphs that are content-addressed using ERIS.</p>
</div>
<div class="paragraph">
<p>The container types define specific operations (i.e. <code>dmc:Add</code> and <code>dmc:Remove</code> for the set container and <code>dmc:Update</code> for the register). All operations are sub-classes of <code>dmc:Operation</code>.</p>
</div>
<div class="paragraph">
<p>The property <code>dmc:container</code> is used to refer to the container the operation acts on.</p>
</div>
<div class="paragraph">
<p>For example the operation for adding an element to the set defined above looks like this:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-turtle" data-lang="turtle">@prefix dmc: &lt;http://purl.org/dmc#&gt; .

&lt;urn:erisx2:AAACG7NGKQZ4ZSR4D4VS3MFQNT5DHHOS7QYNSH5MCQR6HTYO6GTSLB43CFDWNBPNZ5FTG2LFW5QM735GNT6Y44QHCSEAGSRIMYCNJ3ND44&gt;
    a dmc:Add ;
    dmc:container &lt;dmc:AAAELYRT24S2SACAPSMGTNYYHCCQHBDGQH3SC3K3Y35PI73SLTA6JTO7S7XTA66LZQ2OKSAZZI4BWXJCGGJLZ74WIWEMXZ2SXDC4JVAFKM&gt; ;
    rdf:value &lt;urn:erisx2:AAAAV4OIFHWY67XFEHAOQVXUOWTYDVG5TEY6S6IW4PJ4SQLVJJF4MIKNDLKUDPPHDCKLBUIAJQ3U2IEARRPFHEHWFW5NJY7BJUGFESPGDQ&gt; .</code></pre>
</div>
</div>
<div class="paragraph">
<p>To ensure that an operation is authorized a signature of the operation by the secret key associated with the root public key of the container is required. For example:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-turtle" data-lang="turtle">@prefix rdf-signify: &lt;http://purl.org/rdf-signify#&gt; .
@prefix rdf: &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .
@prefix xsd: &lt;http://www.w3.org/2001/XMLSchema#&gt; .

&lt;urn:erisx2:AAAHZ5E6BYXD7Y3LU625HGB5OXRBLZJQ5TXURD5S5PWCIHEVI7IKKIUF7B5PQRIO52VIEARK5Y2WT4L5BEKF2AXJHN5H3M34XLYJO6HKF4&gt;
    a rdf-signify:Signature ;
    rdf-signify:message &lt;urn:erisx2:AAACG7NGKQZ4ZSR4D4VS3MFQNT5DHHOS7QYNSH5MCQR6HTYO6GTSLB43CFDWNBPNZ5FTG2LFW5QM735GNT6Y44QHCSEAGSRIMYCNJ3ND44&gt; ;
    rdf:value "HOmPzPF8lbUyv/p9Nho/43aFFsLI9y9TiL0vvAHgemesmBt3smNV+2KY/AuZqE756a0jeLkw1dxZPRiu9zrTCg=="^^xsd:base64Binary ;
    rdf-signify:publicKey &lt;urn:ed25519:pk:O7RZC7XVKCRU4LFT4ACSBP3GQ55PPGBZHCBQJMJ46VKJN63HOMSA&gt; .</code></pre>
</div>
</div>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<div class="title">Note</div>
</td>
<td class="content">
Both operation signature are content-addressed using ERIS and immutable.
</td>
</tr>
</table>
</div>
<div class="paragraph">
<p>We introduce a helper predicate that can decide if an operation is authorized for a container:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-datalog" data-lang="datalog">operationAuthorized(Container, Operation) :-
    graph(Container, dmc:rootPublicKey, RootPublicKey),
    graph(Operation, dmc:container, Container),
    graph(Signature, a, rdf-signify:Signature),
    graph(Signature, rdf-signify:message, Operation),
    graph(Signature, rdf:value, SignatureValue),
    ed25519Verify(SignatureValue, Operation, RootPublicKey).</code></pre>
</div>
</div>
<div class="paragraph">
<p>The predicate <code>operationAuthorized(Container,Operation)</code> holds if operation <code>Operation</code> is an authorized operation on container <code>Container</code>.</p>
</div>
</div>
<div class="sect2">
<h3 id="_state"><a class="anchor" href="#_state"></a>3.4. State</h3>
<div class="paragraph">
<p>A container identifier is resolved to a container state that is a description of the current state of the container. The exact semantics of how the container state is resolved is defined in section <a href="#_container_types">Container types</a> for the different container types.</p>
</div>
<div class="paragraph">
<p>For example the state of the set defined above would be resolved as follows after two elements have been added:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-turtle" data-lang="turtle">@prefix dmc: &lt;http://purl.org/dmc#&gt; .

&lt;dmc:AAAELYRT24S2SACAPSMGTNYYHCCQHBDGQH3SC3K3Y35PI73SLTA6JTO7S7XTA66LZQ2OKSAZZI4BWXJCGGJLZ74WIWEMXZ2SXDC4JVAFKM&gt;
    a dmc:Set ;
    dmc:rootPublicKey &lt;urn:ed25519:pk:O7RZC7XVKCRU4LFT4ACSBP3GQ55PPGBZHCBQJMJ46VKJN63HOMSA&gt; ;
    dmc:member &lt;urn:erisx2:AAAAV4OIFHWY67XFEHAOQVXUOWTYDVG5TEY6S6IW4PJ4SQLVJJF4MIKNDLKUDPPHDCKLBUIAJQ3U2IEARRPFHEHWFW5NJY7BJUGFESPGDQ&gt; ;
    dmc:member &lt;urn:erisx2:AAAF5Q7CXYPZH63IQ3EF4YVMBOEC6YFQH6JQ7YQMG2QYMKDJLWM5LHXRA6XBHJGKMCJL7QTWAH4PFCTDVXIIKP7HOTKGVVIOOAUAXKFNUE&gt; .</code></pre>
</div>
</div>
<div class="paragraph">
<p>Note that the state depends on available operations on the container. Operation transport and synchronization are beyond the scope of this document, we assume that the available operations are given in an RDF graph. Some ideas on how operation transport and synchronization might work are illustrated in section <a href="#_applications">[_applications]</a>.</p>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_container_types"><a class="anchor" href="#_container_types"></a>4. Container types</h2>
<div class="sectionbody">
<div class="sect2">
<h3 id="_set"><a class="anchor" href="#_set"></a>4.1. Set</h3>
<div class="paragraph">
<p>Sets are unordered collections that hold distinct members. They are a useful base data structure for building complex applications.</p>
</div>
<div class="paragraph">
<p>Adding and removing elements from a set are, in general, non-commutative operations:</p>
</div>
<div class="stemblock">
<div class="content">
\${x} vv {x} \\ {x} !=  {x} \\ {x} vv {x}.\$
</div>
</div>
<div class="paragraph">
<p>We will use a little trick to solve this problem. The data structure that implements this trick is called an <em>Observed-Remove Set (OR-Set)</em>.</p>
</div>
<div class="sect3">
<h4 id="_observed_remove_set"><a class="anchor" href="#_observed_remove_set"></a>4.1.1. Observed-Remove Set</h4>
<div class="paragraph">
<p>Instead of keeping track of only the elements in the set, we keep track of tuples of elements along with an unique identifier of the operation that was used to add the element:</p>
</div>
<div class="olist arabic">
<ol class="arabic">
<li>
<p>Applying the operations \$o_1\$ which adds the element \$a\$ to the an empty set container results in \${(o_1,a)}\$.</p>
</li>
<li>
<p>We again add the element \$a\$ with the operation \$o_2\$ resulting in \${(o_1, a), (o_2,a)}\$</p>
</li>
</ol>
</div>
<div class="paragraph">
<p>This set of tuples is just an internal representation. The exposed set is \${a}\$.</p>
</div>
<div class="paragraph">
<p>When removing an element we must specify the element and operation that added the element: After removing the element \$a\$ that was added with operation \$o_1\$ the internal representation of the set is \${o_2, a}\$. The exposed set remains \${a}\$.</p>
</div>
<div class="paragraph">
<p>It can be shown that the operations (add and remove) on an OR-Set commute.</p>
</div>
<div class="paragraph">
<p>The reader is referred to Shapiro et. al. <a href="#crdt">[crdt]</a> for a formal treatment of the Observed-Remove Set.</p>
</div>
</div>
<div class="sect3">
<h4 id="_definition_2"><a class="anchor" href="#_definition_2"></a>4.1.2. Definition</h4>
<div class="paragraph">
<p>A set is defined by creating a container definition of type <code>dmc:SetDefinition</code> (see example in section <a href="#_definition">Definition</a>).</p>
</div>
</div>
<div class="sect3">
<h4 id="_operations_2"><a class="anchor" href="#_operations_2"></a>4.1.3. Operations</h4>
<div class="paragraph">
<p>There are two operations that mutate a set container:</p>
</div>
<div class="dlist">
<dl>
<dt class="hdlist1"><code>dmc:Add</code> </dt>
<dd>
<p>Adds an element to the set. The element is referred to by the <code>rdf:value</code> property.</p>
</dd>
<dt class="hdlist1"><code>dmc:Remove</code> </dt>
<dd>
<p>Removes an element from the set. Instead of referring to the element to be removed directly, the operation refers to the <code>dmc:Add</code> operation that added the elements to be removed with the property <code>dmc:operation</code> (see <a href="#_observed_remove_set">Observed-Remove Set</a>).</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_state_2"><a class="anchor" href="#_state_2"></a>4.1.4. State</h4>
<div class="paragraph">
<p>The following Datalog program and the predicate <code>setMember(Container,Member)</code> defines the current members of the set given operations in the graph (predicate <code>graph</code>):</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-datalog" data-lang="datalog">setOperationRemoved(Container,Operation) :-
   graph(Operation, a, dmc:Add),
   graph(Operation, dmc:container, Container),
   graph(RemoveOperation, dmc:operation, Operation),
   graph(RemoveOperation, a, dmc:Remove),
   operationAuthorized(Container, RemoveOperation).

setMember(Container, Member) :-
    graph(Container, a, dmc:Set),
    graph(Operation, a, dmc:Add),
    graph(Operation, rdf:value, Member),
    operationAuthorized(Container, Operation),
    ! setOperationRemoved(Container, Operation).</code></pre>
</div>
</div>
<div class="paragraph">
<p>The helper predicate <code>setOperationRemoved</code> checks if the operation has been "removed".</p>
</div>
<div class="paragraph">
<p>Members of the set are added to the container state using the <code>dmc:member</code> property (see example in section <a href="#_state">State</a>).</p>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_register"><a class="anchor" href="#_register"></a>4.2. Register</h3>
<div class="paragraph">
<p>A register is a datastructure that holds at most a single element. This is useful for singleton objects that can be updated such as user profiles.</p>
</div>
<div class="paragraph">
<p>The DMC register is based on a Last-Writer-Wins register.</p>
</div>
<div class="sect3">
<h4 id="_last_writer_wins_register"><a class="anchor" href="#_last_writer_wins_register"></a>4.2.1. Last-Writer-Wins Register</h4>
<div class="paragraph">
<p>A Last-Writer-Wins Register (LWW-Register) <a href="#crdt">[crdt]</a> creates an order on updates that change the value by adding a timestamp. The current value is the value of the update with the greatest timestamp.</p>
</div>
<div class="paragraph">
<p>Note that this requires a form of weak-coordination, namely having timestamps that are consistent wit causal order. It also permits a denial-of-service attack as a malicious agent who is authorized to update the register may use a extremely high timestamp and block updates from other authorized agents (until they have adapted to using an even higher timestamp). The DMC register is not suited for potentially malicious agents that share control over the register. Nevertheless, we believe it is a valuable datastructure for containers where control is kept very tight and authorized agents are trusted to a high degree. A concrete application is user profiles.</p>
</div>
</div>
<div class="sect3">
<h4 id="_definition_3"><a class="anchor" href="#_definition_3"></a>4.2.2. Definition</h4>
<div class="paragraph">
<p>A register is defined by creating a container definition of type <code>dmc:RegisterDefinition</code>.</p>
</div>
</div>
<div class="sect3">
<h4 id="_operations_3"><a class="anchor" href="#_operations_3"></a>4.2.3. Operations</h4>
<div class="paragraph">
<p>There is only one operation to mutate a register:</p>
</div>
<div class="dlist">
<dl>
<dt class="hdlist1"><code>dmc:Update</code> </dt>
<dd>
<p>Updates the value of the register. A timestamp must be included with the property <code>dmc:timestamp</code>. The value to which the register to be updated to is defined with the <code>rdf:value</code> property.</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_state_3"><a class="anchor" href="#_state_3"></a>4.2.4. State</h4>
<div class="paragraph">
<p>The following Datalog program and the predicate <code>registerValue`</code> defines the current value of the register given the operations in a graph:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-datalog" data-lang="datalog">registerUpdateTimestampValue(Register, Timestamp, Value) :-
    graph(Operation, a, dmc:Update),
    graph(Operation, dmc:container, Register),
    graph(Operation, dmc:timestamp, Timestamp),
    graph(Operation, rdf:value, Value),
    operationAuthorized(Register, Operation).

registerValue(Register, Value) :-
    _ = max Timestamp : registerUpdateTimestampValue(Register, Timestamp, Value).</code></pre>
</div>
</div>
<div class="paragraph">
<p>The <code>registerUpdateTimestampValue</code> is a helper predicate to get all authorized updates with timestamps and values.</p>
</div>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<div class="title">Note</div>
</td>
<td class="content">
Soufflé has only recently added the aggregation functionality required in the <code>registerValue</code> predicate (not included in version 2.0.2).
</td>
</tr>
</table>
</div>
<div class="paragraph">
<p>The state is encoded with type <code>dmc:Register</code> and the current value is indicated with the <code>rdf:value</code> property.</p>
</div>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<div class="title">Note</div>
</td>
<td class="content">
The register may be in a state where it does not hold any value if there has been no update operation.
</td>
</tr>
</table>
</div>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_further_work"><a class="anchor" href="#_further_work"></a>5. Further work</h2>
<div class="sectionbody">
<div class="paragraph">
<p>This initial version is a proof-of-concept intended to start community discussion and get feedback. Following work is planned:</p>
</div>
<div class="ulist">
<ul>
<li>
<p>Implementation as underlying containers for an ActivityPub service. This will be done as next milestone in the openEngiadina project. We hope to gain more experience and refine this write-up. A Guile Datalog implementation is also being prepared that will allow easier experimentation with the containers presented.</p>
</li>
<li>
<p>Delegated authorization: Currently there is only a single root public-key for every container. We would like to investigate how authorization can be delegated in a more fine-grained manner without sharing the root secret-key. Previous related work includes the Vegvisir project <a href="#vegivisir">[vegivisir]</a>.</p>
</li>
<li>
<p>Garbage collection: Further work is required to describe how operations and previous states can be forgotten.</p>
</li>
<li>
<p>More efficient serialization. For storage and network transport we currently use the S-Expression based serialization presented for content-addressing RDF. This serialization is quite verbose and can not be directly queried. We would like to investigate formats such as HDT <a href="#hdt">[hdt]</a>.</p>
</li>
<li>
<p>This specification relies on previous work that still requires refinement and finalization (ERIS, Content-addressable RDF and RDF Signify).</p>
</li>
</ul>
</div>
<div class="paragraph">
<p>Implementation in an ActivityPub service and more practical aspects will be worked on in the context of the <a href="https://openengiadina.net/">openEngiadina</a> project (supported by NGI0 via NLNet). More technical aspects (e.g. delegated authorization) as well as peer-to-peer transport layers will be researched in the context of the <a href="https://dream.public.cat/">DREAM</a> project (supported by NGI Pointer).</p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_acknowledgments"><a class="anchor" href="#_acknowledgments"></a>6. Acknowledgments</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Many thanks to the DREAM team for support and valuable discussions as well as to Christian Weilbach for sparking a deep interest in Datalog.</p>
</div>
<div class="paragraph">
<p>I would like to acknowledge the value of <a href="https://sci-hub.se/">Sci-Hub</a> and <a href="http://libgen.rs/">Library Genesis</a> for this work. Independent research such as this would not be possible without liberated access to knowledge. <a href="https://custodians.online/">Water the flowers - clean the volcanoes.</a></p>
</div>
<div class="paragraph">
<p>This work has been supported by the <a href="https://nlnet.nl/">NLNet Foundation</a> trough the <a href="https://nlnet.nl/discovery/">NGI0 Discovery Fund</a>.</p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_rdf_vocabulary"><a class="anchor" href="#_rdf_vocabulary"></a>Appendix A: RDF Vocabulary</h2>
<div class="sectionbody">
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-turtle" data-lang="turtle">@prefix dmc: &lt;http://purl.org/dmc#&gt; .
@prefix rdf: &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; .
@prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt; .
@prefix owl: &lt;http://www.w3.org/2002/07/owl#&gt; .

&lt;http://purl.org/dmc#&gt;
    a owl:Ontology ;
    rdfs:label "Distributed Mutable Containers" ;
    rdfs:comment "Vocabulary for describing state and operations of Distributed Mutable Containers" .

dmc:Container
    a rdfs:Class ;
    rdfs:label "Distributed Mutable Container" .

dmc:rootPublicKey
    a rdfs:Property ;
    rdfs:domain dmc:Container ;
    rdf:label "root public-key" ;
    rdfs:comment "The root public-key of the container" .

dmc:container
    a rdfs:Property ;
    rdfs:range dmc:Container ;
    rdfs:label "container" ;
    rdfs:comment "The associated container." .

dmc:ContainerDefinition
   rdfs:subClassOf dmc:Container ;
   rdfs:label "contaner definition" ;
   rdfs:comment "Definition of a Distributed Mutable Container" .

dmc:State
   rdfs:subClassOf dmc:Container ;
   rdfs:label "container state" ;
   rdfs:comment "State of a Distributed Mutable Container" .

dmc:Operation
    a rdfs:Class ;
    rdf:label "operation" ;
    rdfs:comment "An operation on a Distributed Mutable Container" .

dmc:SetDefinition
    rdfs:subClassOf dmc:ContainerDefinition ;
    rdfs:label "set definition" ;
    rdfs:comment "Definition of a Set" .

dmc:Set
    rdfs:subClassOf dmc:State .

dmc:member
    a rdfs:Property ;
    rdfs:domain dmc:Set .

dmc:Add
    a rdfs:Class ;
    rdfs:subClassOf dmc:Operation .

dmc:Remove
    a rdfs:Class ;
    rdfs:subClassOf dmc:Operation .

dmc:operation
    a rdfs:Property ;
    rdfs:domain dmc:Remove;
    rdfs:range dmc:Add;
    rdfs:label "operation" .

dmc:RegisterDefinition
    rdfs:subClassOf dmc:ContainerDefinition .

dmc:Register
    rdfs:subClassOf dmc:state .

dmc:Update
    a rdfs:Class ;
    rdfs:subClassOf dmc:Operation .

dmc:timestamp
    a rdfs:Property ;
    rdfs:domain dmc:Update .</code></pre>
</div>
</div>
<div class="paragraph">
<p>The vocabulary is also provided as <a href="https://openengiadina.gitlab.io/dmc/dmc.ttl">Turtle file</a>.</p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_copyright"><a class="anchor" href="#_copyright"></a>Appendix B: Copyright</h2>
<div class="sectionbody">
<div class="paragraph">
<p>This work is licensed under a <a href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.</p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_references"><a class="anchor" href="#_references"></a>References</h2>
<div class="sectionbody">
<div class="ulist bibliography">
<ul class="bibliography">
<li>
<p><a id="crdt"></a>[crdt] Marc Shapiro, Nuno Preguiça, Carlos Baquero, Marek Zawirski. <a href="https://hal.inria.fr/inria-00555588/document">A comprehensive study of Convergent and Commutative Replicated Data Types</a>.  [Research Report] RR-7506, Inria – Centre Paris-Rocquencourt; INRIA. 2011, pp.50.</p>
</li>
<li>
<p><a id="content-addressable-rdf"></a>[content-addressable-rdf] openEngiadina. <a href="https://openengiadina.net/papers/content-addressable-rdf.html">Content-addressable RDF</a>. 2020</p>
</li>
<li>
<p><a id="eris"></a>[eris] openEngiadina. <a href="https://openengiadina.net/papers/eris.html">Encoding for Robust Immutable Storage</a>. 2020</p>
</li>
<li>
<p><a id="rdf-signify"></a>[rdf-signify] openEngiadina. <a href="https://openengiadina.net/papers/rdf-signify.html">RDF Signify</a>. 2020</p>
</li>
<li>
<p><a id="vegvisir"></a>[vegvisir] Kolbeinn Karlsson, Danny Adams, Edwin Ma, Weitao Jiang, Robbert van Renesse, Hakim Weatherspoon, and Stephen Wicker <a href="https://vegvisir.cs.cornell.edu/html/files/papers/vegvisir-paper.pdf">Vegvisir: A Partition-Tolerant Blockchain for the Internet-of-Things</a> In the 2018 IEEE 38th International Conference on Distrbuted Computing Systems(ICDCS), Vienna, Austria, July 2018.</p>
</li>
<li>
<p><a id="calm"></a>[calm] Hellerstein, Joseph M., and Peter Alvaro. <a href="https://arxiv.org/pdf/1901.01930.pdf">"Keeping CALM: when distributed consistency is easy."</a> arXiv preprint arXiv:1901.01930 (2019).</p>
</li>
<li>
<p><a id="datalog"></a>[datalog] Ceri, Stefano, Georg Gottlob, and Letizia Tanca. <a href="https://personal.utdallas.edu/~gupta/courses/acl/papers/datalog-paper.pdf">"What you always wanted to know about Datalog(and never dared to ask)."</a> IEEE transactions on knowledge and data engineering 1.1 (1989): 146-166.</p>
</li>
<li>
<p><a id="hdt"></a>[hdt] Fernández, Javier D., et al. "Binary RDF representation for publication and exchange (HDT)." Journal of Web Semantics 19 (2013): 22-41.</p>
</li>
</ul>
</div>
</div>
</div>
</div>
<div id="footer">
<div id="footer-text">
Version 0.1.0<br>
Last updated 2020-10-19 07:59:25 +0200
</div>
</div>
<script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains('stemblock')) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script>
</body>
</html>